#include <Verso/Math/ColorGenerator.hpp>

namespace Verso {


std::vector<RgbaColorf> ColorGenerator::colors;
std::map<std::string, ColorRgb> ColorGenerator::stringToColor;
std::map<ColorRgb, std::string> ColorGenerator::colorToString;


void ColorGenerator::setupColors()
{
	const float alpha = 1.0;

	colors.clear();
	colors.reserve(static_cast<std::size_t>(ColorRgb::Last));

	colors[static_cast<std::size_t>(ColorRgb::Black)] = RgbaColorf(0/255.0f, 0/255.0f, 0/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Silver)] = RgbaColorf(192.0f/255.0f, 192.0f/255.0f, 192.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Gray)] = RgbaColorf(128.0f/255.0f, 128.0f/255.0f, 128.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::White)] = RgbaColorf(255.0f/255.0f, 255.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Maroon)] = RgbaColorf(128.0f/255.0f, 0.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Red)] = RgbaColorf(255.0f/255.0f, 0.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Purple)] = RgbaColorf(128.0f/255.0f, 0.0f/255.0f, 128.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Fuchsia)] = RgbaColorf(255.0f/255.0f, 0.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Green)] = RgbaColorf(0.0f/255.0f, 128.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Lime)] = RgbaColorf(0.0f/255.0f, 255.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Olive)] = RgbaColorf(128.0f/255.0f, 128.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Yellow)] = RgbaColorf(255.0f/255.0f, 255.0f/255.0f ,0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Navy)] = RgbaColorf(0.0f/255.0f, 0.0f/255.0f, 128.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Blue)] = RgbaColorf(0.0f/255.0f, 0.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Teal)] = RgbaColorf(0.0f/255.0f, 128.0f/255.0f, 128.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Aqua)] = RgbaColorf(0.0f/255.0f, 255.0f/255.0f, 255.0f/255.0f, alpha);

	colors[static_cast<std::size_t>(ColorRgb::AliceBlue)] = RgbaColorf(240.0f/255.0f, 248.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::AntiqueWhite)] = RgbaColorf(250.0f/255.0f, 235.0f/255.0f, 215.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::AntiqueWhite2)] = RgbaColorf(255.0f/255.0f, 239.0f/255.0f, 219.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::AntiqueWhite3)] = RgbaColorf(238.0f/255.0f, 223.0f/255.0f, 204.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::AntiqueWhite4)] = RgbaColorf(205.0f/255.0f, 192.0f/255.0f, 176.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::AntiqueWhite5)] = RgbaColorf(139.0f/255.0f, 131.0f/255.0f, 120.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Aquamarine)] = RgbaColorf(127.0f/255.0f, 255.0f/255.0f, 212.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Aquamarine2)] = RgbaColorf(118.0f/255.0f, 238.0f/255.0f, 198.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Aquamarine3)] = RgbaColorf(69.0f/255.0f, 139.0f/255.0f, 116.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Azure)] = RgbaColorf(240.0f/255.0f, 255.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Beige)] = RgbaColorf(245.0f/255.0f, 245.0f/255.0f, 220.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Bisque)] = RgbaColorf(255.0f/255.0f, 228.0f/255.0f, 196.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlanchedAlmond)] = RgbaColorf(255.0f/255.0f, 235.0f/255.0f, 205.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlenderBackground)] = RgbaColorf(57.0f/255.0f, 57.0f/255.0f, 57.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlenderGridPlaneGray)] = RgbaColorf(74.0f/255.0f, 74.0f/255.0f, 74.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlenderGridPlaneX)] = RgbaColorf(132.0f/255.0f, 22.0f/255.0f, 22.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlenderGridPlaneY)] = RgbaColorf(22.0f/255.0f, 132.0f/255.0f, 22.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlenderGridPlaneZ)] = RgbaColorf(22.0f/255.0f, 22.0f/255.0f, 132.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlenderFlatObject)] = RgbaColorf(157.0f/255.0f, 158.0f/255.0f, 165.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlenderHighlight)] = RgbaColorf(255.0f/255.0f, 170.0f/255.0f, 64.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BlueViolet)] = RgbaColorf(138.0f/255.0f, 43.0f/255.0f, 226.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Brown)] = RgbaColorf(165.0f/255.0f, 42.0f/255.0f, 42.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::BurlyWood)] = RgbaColorf(222.0f/255.0f, 184.0f/255.0f, 135.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::CadetBlue)] = RgbaColorf(95.0f/255.0f, 158.0f/255.0f, 160.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Chartreuse)] = RgbaColorf(127.0f/255.0f, 255.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Chocolate)] = RgbaColorf(210.0f/255.0f, 105.0f/255.0f, 30.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Coral)] = RgbaColorf(255.0f/255.0f, 127.0f/255.0f, 80.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::CornFlowerBlue)] = RgbaColorf(100.0f/255.0f, 149.0f/255.0f, 237.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::CornSilk)] = RgbaColorf(255.0f/255.0f, 248.0f/255.0f, 220.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Crimson)] = RgbaColorf(220.0f/255.0f, 20.0f/255.0f, 60.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Cyan)] = RgbaColorf(0.0f/255.0f, 255.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkBlue)] = RgbaColorf(0.0f/255.0f, 0.0f/255.0f, 139.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkCyan)] = RgbaColorf(0.0f/255.0f, 139.0f/255.0f, 139.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkGoldenRod)] = RgbaColorf(184.0f/255.0f, 134.0f/255.0f, 11.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkGray)] = RgbaColorf(169.0f/255.0f, 169.0f/255.0f, 169.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkGreen)] = RgbaColorf(0.0f/255.0f, 100.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkGrey)] = RgbaColorf(169.0f/255.0f, 169.0f/255.0f, 169.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkKhaki)] = RgbaColorf(189.0f/255.0f, 183.0f/255.0f, 107.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkMagenta)] = RgbaColorf(139.0f/255.0f, 0.0f/255.0f, 139.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkOliveGreen)] = RgbaColorf(85.0f/255.0f, 107.0f/255.0f, 47.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkOrange)] = RgbaColorf(255.0f/255.0f, 140.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkOrange2)] = RgbaColorf(255.0f/255.0f, 127.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkOrange3)] = RgbaColorf(238.0f/255.0f, 118.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkOrange4)] = RgbaColorf(205.0f/255.0f, 102.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkOrange5)] = RgbaColorf(139.0f/255.0f, 69.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkOrchid)] = RgbaColorf(153.0f/255.0f, 50.0f/255.0f, 204.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkRed)] = RgbaColorf(139.0f/255.0f, 0.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSalmon)] = RgbaColorf(233.0f/255.0f, 150.0f/255.0f, 122.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSeaGreen)] = RgbaColorf(143.0f/255.0f, 188.0f/255.0f, 143.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSeaGreen2)] = RgbaColorf(193.0f/255.0f, 255.0f/255.0f, 193.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSeaGreen3)] = RgbaColorf(180.0f/255.0f, 238.0f/255.0f, 180.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSeaGreen4)] = RgbaColorf(155.0f/255.0f, 205.0f/255.0f, 155.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSeaGreen5)] = RgbaColorf(105.0f/255.0f, 139.0f/255.0f, 105.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSlateBlue)] = RgbaColorf(72.0f/255.0f, 61.0f/255.0f, 139.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSlateGray)] = RgbaColorf(47.0f/255.0f, 79.0f/255.0f, 79.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkSlateGrey)] = RgbaColorf(47.0f/255.0f, 79.0f/255.0f, 79.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkTurquoise)] = RgbaColorf(0.0f/255.0f, 206.0f/255.0f, 209.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DarkViolet)] = RgbaColorf(148.0f/255.0f, 0.0f/255.0f, 211.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DeepPink)] = RgbaColorf(255.0f/255.0f, 20.0f/255.0f, 147.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DeepPink2)] = RgbaColorf(238.0f/255.0f, 18.0f/255.0f, 137.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DeepPink3)] = RgbaColorf(205.0f/255.0f, 16.0f/255.0f, 118.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DeepPink4)] = RgbaColorf(139.0f/255.0f, 10.0f/255.0f, 80.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DeepSkyBlue)] = RgbaColorf(0.0f/255.0f, 191.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DimGray)] = RgbaColorf(105.0f/255.0f, 105.0f/255.0f, 105.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DimGrey)] = RgbaColorf(105.0f/255.0f, 105.0f/255.0f, 105.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::DodgerBlue)] = RgbaColorf(30.0f/255.0f, 144.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::FireBrick)] = RgbaColorf(178.0f/255.0f, 34.0f/255.0f, 34.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::FloralWhite)] = RgbaColorf(255.0f/255.0f, 250.0f/255.0f, 240.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::ForestGreen)] = RgbaColorf(34.0f/255.0f, 139.0f/255.0f, 34.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Gainsboro)] = RgbaColorf(220.0f/255.0f, 220.0f/255.0f, 220.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::GhostWhite)] = RgbaColorf(248.0f/255.0f, 248.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Gold)] = RgbaColorf(255.0f/255.0f, 215.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::GoldenRod)] = RgbaColorf(218.0f/255.0f, 165.0f/255.0f, 32.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::GreenYellow)] = RgbaColorf(173.0f/255.0f, 255.0f/255.0f, 47.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Grey)] = RgbaColorf(128.0f/255.0f, 128.0f/255.0f, 128.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::HoneyDew)] = RgbaColorf(240.0f/255.0f, 255.0f/255.0f, 240.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::HotPink)] = RgbaColorf(255.0f/255.0f, 105.0f/255.0f, 180.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::HotPink2)] = RgbaColorf(255.0f/255.0f, 110.0f/255.0f, 180.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::HotPink3)] = RgbaColorf(238.0f/255.0f, 106.0f/255.0f, 167.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::HotPink4)] = RgbaColorf(205.0f/255.0f, 96.0f/255.0f, 144.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::HotPink5)] = RgbaColorf(139.0f/255.0f, 58.0f/255.0f, 98.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::IndianRed)] = RgbaColorf(205.0f/255.0f, 92.0f/255.0f, 92.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Indigo)] = RgbaColorf(75.0f/255.0f, 0.0f/255.0f, 130.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Ivory)] = RgbaColorf(255.0f/255.0f, 255.0f/255.0f, 240.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Khaki)] = RgbaColorf(240.0f/255.0f, 230.0f/255.0f, 140.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Lavender)] = RgbaColorf(230.0f/255.0f, 230.0f/255.0f, 250.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LavenderBlush)] = RgbaColorf(255.0f/255.0f, 240.0f/255.0f, 245.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LawnGreen)] = RgbaColorf(124.0f/255.0f, 252.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LemonChiffon)] = RgbaColorf(255.0f/255.0f, 250.0f/255.0f, 205.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightBlue)] = RgbaColorf(173.0f/255.0f, 216.0f/255.0f, 230.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightCoral)] = RgbaColorf(240.0f/255.0f, 128.0f/255.0f, 128.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightCyan)] = RgbaColorf(224.0f/255.0f, 255.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightGoldenRodYellow)] = RgbaColorf(250.0f/255.0f, 250.0f/255.0f, 210.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightGray)] = RgbaColorf(211.0f/255.0f, 211.0f/255.0f, 211.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightGreen)] = RgbaColorf(144.0f/255.0f, 238.0f/255.0f, 144.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightGrey)] = RgbaColorf(211.0f/255.0f, 211.0f/255.0f, 211.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightPink)] = RgbaColorf(255.0f/255.0f, 182.0f/255.0f, 193.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightSalmon)] = RgbaColorf(255.0f/255.0f, 160.0f/255.0f, 122.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightSeaGreen)] = RgbaColorf(32.0f/255.0f, 178.0f/255.0f, 170.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightSkyBlue)] = RgbaColorf(135.0f/255.0f, 206.0f/255.0f, 250.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightSlateGray)] = RgbaColorf(119.0f/255.0f, 136.0f/255.0f, 153.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightSlateGrey)] = RgbaColorf(119.0f/255.0f, 136.0f/255.0f, 153.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightSteelBlue)] = RgbaColorf(176.0f/255.0f, 196.0f/255.0f, 222.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LightYellow)] = RgbaColorf(255.0f/255.0f, 255.0f/255.0f, 224.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::LimeGreen)] = RgbaColorf(50.0f/255.0f, 205.0f/255.0f, 50.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Linen)] = RgbaColorf(250.0f/255.0f, 240.0f/255.0f, 230.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Magenta)] = RgbaColorf(255.0f/255.0f, 0.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumAquamarine)] = RgbaColorf(102.0f/255.0f, 205.0f/255.0f, 170.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumBlue)] = RgbaColorf(0.0f/255.0f, 0.0f/255.0f, 205.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumOrchid)] = RgbaColorf(186.0f/255.0f, 85.0f/255.0f, 211.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumPurple)] = RgbaColorf(147.0f/255.0f, 112.0f/255.0f, 219.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumSeaGreen)] = RgbaColorf(60.0f/255.0f, 179.0f/255.0f, 113.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumSlateBlue)] = RgbaColorf(123.0f/255.0f, 104.0f/255.0f, 238.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumSpringGreen)] = RgbaColorf(0.0f/255.0f, 250.0f/255.0f, 154.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumTurquoise)] = RgbaColorf(72.0f/255.0f, 209.0f/255.0f, 204.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MediumVioletRed)] = RgbaColorf(199.0f/255.0f, 21.0f/255.0f, 133.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MidnightBlue)] = RgbaColorf(25.0f/255.0f, 25.0f/255.0f, 112.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MintCream)] = RgbaColorf(245.0f/255.0f, 255.0f/255.0f, 250.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MistyRose)] = RgbaColorf(255.0f/255.0f, 228.0f/255.0f, 225.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MistyRose2)] = RgbaColorf(238.0f/255.0f, 213.0f/255.0f, 210.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MistyRose3)] = RgbaColorf(205.0f/255.0f, 183.0f/255.0f, 181.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::MistyRose4)] = RgbaColorf(139.0f/255.0f, 125.0f/255.0f, 123.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Moccasin)] = RgbaColorf(255.0f/255.0f, 228.0f/255.0f, 181.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::NavajoWhite)] = RgbaColorf(255.0f/255.0f, 222.0f/255.0f, 173.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::NavajoWhite2)] = RgbaColorf(238.0f/255.0f, 207.0f/255.0f, 161.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::NavajoWhite3)] = RgbaColorf(205.0f/255.0f, 179.0f/255.0f, 139.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::NavajoWhite4)] = RgbaColorf(139.0f/255.0f, 121.0f/255.0f, 94.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::NiceOrange)] = RgbaColorf(255.0f/255.0f, 102.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::NiceBackgroundGray)] = RgbaColorf(57.0f/255.0f, 65.0f/255.0f, 67.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::NiceBackgroundGray2)] = RgbaColorf(114.0f/255.0f, 107.0f/255.0f, 104.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::OldLace)] = RgbaColorf(253.0f/255.0f, 245.0f/255.0f, 230.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::OliveDrab)] = RgbaColorf(107.0f/255.0f, 142.0f/255.0f, 35.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Orange)] = RgbaColorf(255.0f/255.0f, 165.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::OrangeRed)] = RgbaColorf(255.0f/255.0f, 69.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::OrangeRed2)] = RgbaColorf(238.0f/255.0f, 64.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::OrangeRed3)] = RgbaColorf(205.0f/255.0f, 55.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::OrangeRed4)] = RgbaColorf(139.0f/255.0f, 37.0f/255.0f, 0.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Orchid)] = RgbaColorf(218.0f/255.0f, 112.0f/255.0f, 214.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleGoldenRod)] = RgbaColorf(238.0f/255.0f, 232.0f/255.0f, 170.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleTurquoise)] = RgbaColorf(175.0f/255.0f, 238.0f/255.0f, 238.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleTurquoise2)] = RgbaColorf(187.0f/255.0f, 255.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleTurquoise3)] = RgbaColorf(174.0f/255.0f, 238.0f/255.0f, 238.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleTurquoise4)] = RgbaColorf(150.0f/255.0f, 205.0f/255.0f, 205.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleTurquoise5)] = RgbaColorf(102.0f/255.0f, 139.0f/255.0f, 139.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleVioletRed)] = RgbaColorf(219.0f/255.0f, 112.0f/255.0f, 147.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleVioletRed2)] = RgbaColorf(255.0f/255.0f, 130.0f/255.0f, 171.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleVioletRed3)] = RgbaColorf(238.0f/255.0f, 121.0f/255.0f, 159.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleVioletRed4)] = RgbaColorf(205.0f/255.0f, 104.0f/255.0f, 137.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleVioletRed5)] = RgbaColorf(139.0f/255.0f, 71.0f/255.0f, 93.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PapayaWhip)] = RgbaColorf(255.0f/255.0f, 239.0f/255.0f, 213.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PeachPuff)] = RgbaColorf(255.0f/255.0f, 218.0f/255.0f, 185.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PeachPuff2)] = RgbaColorf(238.0f/255.0f, 203.0f/255.0f, 173.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PeachPuff3)] = RgbaColorf(205.0f/255.0f, 175.0f/255.0f, 149.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PeachPuff4)] = RgbaColorf(139.0f/255.0f, 119.0f/255.0f, 101.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Peru)] = RgbaColorf(205.0f/255.0f, 133.0f/255.0f, 63.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Pink)] = RgbaColorf(255.0f/255.0f, 192.0f/255.0f, 203.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Plum)] = RgbaColorf(221.0f/255.0f, 160.0f/255.0f, 221.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PowderBlue)] = RgbaColorf(176.0f/255.0f, 224.0f/255.0f, 230.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::RosyBrown)] = RgbaColorf(188.0f/255.0f, 143.0f/255.0f, 143.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::RoyalBlue)] = RgbaColorf(65.0f/255.0f, 105.0f/255.0f, 225.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SaddleBrown)] = RgbaColorf(139.0f/255.0f, 69.0f/255.0f, 19.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Salmon)] = RgbaColorf(250.0f/255.0f, 128.0f/255.0f, 114.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SandyBrown)] = RgbaColorf(244.0f/255.0f, 164.0f/255.0f, 96.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SeaGreen)] = RgbaColorf(84.0f/255.0f, 255.0f/255.0f, 159.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SeaGreen2)] = RgbaColorf(78.0f/255.0f, 238.0f/255.0f, 148.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SeaGreen3)] = RgbaColorf(67.0f/255.0f, 205.0f/255.0f, 128.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SeaGreen4)] = RgbaColorf(46.0f/255.0f, 139.0f/255.0f, 87.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SeaShell)] = RgbaColorf(255.0f/255.0f, 245.0f/255.0f, 238.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Sienna)] = RgbaColorf(160.0f/255.0f, 82.0f/255.0f, 45.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SkyBlue)] = RgbaColorf(135.0f/255.0f, 206.0f/255.0f, 235.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SlateBlue)] = RgbaColorf(106.0f/255.0f, 90.0f/255.0f, 205.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SlateGray)] = RgbaColorf(112.0f/255.0f, 128.0f/255.0f, 144.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SlateGrey)] = RgbaColorf(112.0f/255.0f, 128.0f/255.0f, 144.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Snow)] = RgbaColorf(255.0f/255.0f, 250.0f/255.0f, 250.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SpringGreen)] = RgbaColorf(0.0f/255.0f, 255.0f/255.0f, 127.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::SteelBlue)] = RgbaColorf(70.0f/255.0f, 130.0f/255.0f, 180.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Tan)] = RgbaColorf(210.0f/255.0f, 180.0f/255.0f, 140.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Thistle)] = RgbaColorf(216.0f/255.0f, 191.0f/255.0f, 216.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Tomato)] = RgbaColorf(255.0f/255.0f, 99.0f/255.0f, 71.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Turquoise)] = RgbaColorf(64.0f/255.0f, 224.0f/255.0f, 208.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Turquoise2)] = RgbaColorf(0.0f/255.0f, 245.0f/255.0f, 255.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Turquoise3)] = RgbaColorf(0.0f/255.0f, 229.0f/255.0f, 238.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Turquoise4)] = RgbaColorf(0.0f/255.0f, 197.0f/255.0f, 205.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Turquoise5)] = RgbaColorf(0.0f/255.0f, 134.0f/255.0f, 139.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Violet)] = RgbaColorf(238.0f/255.0f, 130.0f/255.0f, 238.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::Wheat)] = RgbaColorf(245.0f/255.0f, 222.0f/255.0f, 179.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::WhiteSmoke)] = RgbaColorf(245.0f/255.0f, 245.0f/255.0f, 245.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::YellowGreen)] = RgbaColorf(154.0f/255.0f, 205.0f/255.0f, 50.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleGreen)] = RgbaColorf(152.0f/255.0f, 251.0f/255.0f, 152.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleGreen2)] = RgbaColorf(154.0f/255.0f, 255.0f/255.0f, 154.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleGreen3)] = RgbaColorf(144.0f/255.0f, 238.0f/255.0f, 144.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleGreen4)] = RgbaColorf(124.0f/255.0f, 205.0f/255.0f, 124.0f/255.0f, alpha);
	colors[static_cast<std::size_t>(ColorRgb::PaleGreen5)] = RgbaColorf(84.0f/255.0f, 139.0f/255.0f, 84.0f/255.0f, alpha);

	colorToString.clear();
	colorToString[ColorRgb::Black] = "black";
	colorToString[ColorRgb::Silver] = "silver";
	colorToString[ColorRgb::Gray] = "gray";
	colorToString[ColorRgb::White] = "white";
	colorToString[ColorRgb::Maroon] = "maroon";
	colorToString[ColorRgb::Red] = "red";
	colorToString[ColorRgb::Purple] = "purple";
	colorToString[ColorRgb::Fuchsia] = "fuchsia";
	colorToString[ColorRgb::Green] = "green";
	colorToString[ColorRgb::Lime] = "lime";
	colorToString[ColorRgb::Olive] = "olive";
	colorToString[ColorRgb::Yellow] = "yellow";
	colorToString[ColorRgb::Navy] = "navy";
	colorToString[ColorRgb::Blue] = "blue";
	colorToString[ColorRgb::Teal] = "teal";
	colorToString[ColorRgb::Aqua] = "aqua";

	colorToString[ColorRgb::AliceBlue] = "aliceblue";
	colorToString[ColorRgb::AntiqueWhite] = "antiquewhite";
	colorToString[ColorRgb::AntiqueWhite2] = "antiquewhite2";
	colorToString[ColorRgb::AntiqueWhite3] = "antiquewhite3";
	colorToString[ColorRgb::AntiqueWhite4] = "antiquewhite4";
	colorToString[ColorRgb::AntiqueWhite5] = "antiquewhite5";
	colorToString[ColorRgb::Aquamarine] = "aquamarine";
	colorToString[ColorRgb::Aquamarine2] = "aquamarine2";
	colorToString[ColorRgb::Aquamarine3] = "aquamarine3";
	colorToString[ColorRgb::Azure] = "azure";
	colorToString[ColorRgb::Beige] = "beige";
	colorToString[ColorRgb::Bisque] = "bisque";
	colorToString[ColorRgb::BlanchedAlmond] = "blanchedalmond";
	colorToString[ColorRgb::BlenderBackground] = "blenderbackground";
	colorToString[ColorRgb::BlenderGridPlaneGray] = "blendergridplanegray";
	colorToString[ColorRgb::BlenderGridPlaneX] = "blendergridplanex";
	colorToString[ColorRgb::BlenderGridPlaneY] = "blendergridplaney";
	colorToString[ColorRgb::BlenderGridPlaneZ] = "blendergridplanez";
	colorToString[ColorRgb::BlenderFlatObject] = "blenderflatobject";
	colorToString[ColorRgb::BlenderHighlight] = "blenderhighlight";
	colorToString[ColorRgb::BlueViolet] = "blueviolet";
	colorToString[ColorRgb::Brown] = "brown";
	colorToString[ColorRgb::BurlyWood] = "burlywood";
	colorToString[ColorRgb::CadetBlue] = "cadetblue";
	colorToString[ColorRgb::Chartreuse] = "chartreuse";
	colorToString[ColorRgb::Chocolate] = "chocolate";
	colorToString[ColorRgb::Coral] = "coral";
	colorToString[ColorRgb::CornFlowerBlue] = "cornflowerblue";
	colorToString[ColorRgb::CornSilk] = "cornsilk";
	colorToString[ColorRgb::Crimson] = "crimson";
	colorToString[ColorRgb::Cyan] = "cyan";
	colorToString[ColorRgb::DarkBlue] = "darkblue";
	colorToString[ColorRgb::DarkCyan] = "darkcyan";
	colorToString[ColorRgb::DarkGoldenRod] = "darkgoldenrod";
	colorToString[ColorRgb::DarkGray] = "darkgray";
	colorToString[ColorRgb::DarkGreen] = "darkgreen";
	colorToString[ColorRgb::DarkGrey] = "darkgrey";
	colorToString[ColorRgb::DarkKhaki] = "darkkhaki";
	colorToString[ColorRgb::DarkMagenta] = "darkmagenta";
	colorToString[ColorRgb::DarkOliveGreen] = "darkolivegreen";
	colorToString[ColorRgb::DarkOrange] = "darkorange";
	colorToString[ColorRgb::DarkOrange2] = "darkorange2";
	colorToString[ColorRgb::DarkOrange3] = "darkorange3";
	colorToString[ColorRgb::DarkOrange4] = "darkorange4";
	colorToString[ColorRgb::DarkOrange5] = "darkorange5";
	colorToString[ColorRgb::DarkOrchid] = "darkorchid";
	colorToString[ColorRgb::DarkRed] = "darkred";
	colorToString[ColorRgb::DarkSalmon] = "darksalmon";
	colorToString[ColorRgb::DarkSeaGreen] = "darkseagreen";
	colorToString[ColorRgb::DarkSeaGreen2] = "darkseagreen2";
	colorToString[ColorRgb::DarkSeaGreen3] = "darkseagreen3";
	colorToString[ColorRgb::DarkSeaGreen4] = "darkseagreen4";
	colorToString[ColorRgb::DarkSeaGreen5] = "darkseagreen5";
	colorToString[ColorRgb::DarkSlateBlue] = "darkslateblue";
	colorToString[ColorRgb::DarkSlateGray] = "darkslategray";
	colorToString[ColorRgb::DarkSlateGrey] = "darkslategrey";
	colorToString[ColorRgb::DarkTurquoise] = "darkturquoise";
	colorToString[ColorRgb::DarkViolet] = "darkviolet";
	colorToString[ColorRgb::DeepPink] = "deeppink";
	colorToString[ColorRgb::DeepPink2] = "deeppink2";
	colorToString[ColorRgb::DeepPink3] = "deeppink3";
	colorToString[ColorRgb::DeepPink4] = "deeppink4";
	colorToString[ColorRgb::DeepSkyBlue] = "deepskyblue";
	colorToString[ColorRgb::DimGray] = "dimgray";
	colorToString[ColorRgb::DimGrey] = "dimgrey";
	colorToString[ColorRgb::DodgerBlue] = "dodgerblue";
	colorToString[ColorRgb::FireBrick] = "firebrick";
	colorToString[ColorRgb::FloralWhite] = "floralwhite";
	colorToString[ColorRgb::ForestGreen] = "forestgreen";
	colorToString[ColorRgb::Gainsboro] = "gainsboro";
	colorToString[ColorRgb::GhostWhite] = "ghostwhite";
	colorToString[ColorRgb::Gold] = "gold";
	colorToString[ColorRgb::GoldenRod] = "goldenrod";
	colorToString[ColorRgb::GreenYellow] = "greenyellow";
	colorToString[ColorRgb::Grey] = "grey";
	colorToString[ColorRgb::HoneyDew] = "honeydew";
	colorToString[ColorRgb::HotPink] = "hotpink";
	colorToString[ColorRgb::HotPink2] = "hotpink2";
	colorToString[ColorRgb::HotPink3] = "hotpink3";
	colorToString[ColorRgb::HotPink4] = "hotpink4";
	colorToString[ColorRgb::HotPink5] = "hotpink5";
	colorToString[ColorRgb::IndianRed] = "indianred";
	colorToString[ColorRgb::Indigo] = "indigo";
	colorToString[ColorRgb::Ivory] = "ivory";
	colorToString[ColorRgb::Khaki] = "khaki";
	colorToString[ColorRgb::Lavender] = "lavender";
	colorToString[ColorRgb::LavenderBlush] = "lavenderblush";
	colorToString[ColorRgb::LawnGreen] = "lawngreen";
	colorToString[ColorRgb::LemonChiffon] = "lemonchiffon";
	colorToString[ColorRgb::LightBlue] = "lightblue";
	colorToString[ColorRgb::LightCoral] = "lightcoral";
	colorToString[ColorRgb::LightCyan] = "lightcyan";
	colorToString[ColorRgb::LightGoldenRodYellow] = "lightgoldenrodyellow";
	colorToString[ColorRgb::LightGray] = "lightgray";
	colorToString[ColorRgb::LightGreen] = "lightgreen";
	colorToString[ColorRgb::LightGrey] = "lightgrey";
	colorToString[ColorRgb::LightPink] = "lightpink";
	colorToString[ColorRgb::LightSalmon] = "lightsalmon";
	colorToString[ColorRgb::LightSeaGreen] = "lightseagreen";
	colorToString[ColorRgb::LightSkyBlue] = "lightskyblue";
	colorToString[ColorRgb::LightSlateGray] = "lightslategray";
	colorToString[ColorRgb::LightSlateGrey] = "lightslategrey";
	colorToString[ColorRgb::LightSteelBlue] = "lightsteelblue";
	colorToString[ColorRgb::LightYellow] = "lightyellow";
	colorToString[ColorRgb::LimeGreen] = "limegreen";
	colorToString[ColorRgb::Linen] = "linen";
	colorToString[ColorRgb::Magenta] = "magenta";
	colorToString[ColorRgb::MediumAquamarine] = "mediumaquamarine";
	colorToString[ColorRgb::MediumBlue] = "mediumblue";
	colorToString[ColorRgb::MediumOrchid] = "mediumorchid";
	colorToString[ColorRgb::MediumPurple] = "mediumpurple";
	colorToString[ColorRgb::MediumSeaGreen] = "mediumseagreen";
	colorToString[ColorRgb::MediumSlateBlue] = "mediumslateblue";
	colorToString[ColorRgb::MediumSpringGreen] = "mediumspringgreen";
	colorToString[ColorRgb::MediumTurquoise] = "mediumturquoise";
	colorToString[ColorRgb::MediumVioletRed] = "mediumvioletred";
	colorToString[ColorRgb::MidnightBlue] = "midnightblue";
	colorToString[ColorRgb::MintCream] = "mintcream";
	colorToString[ColorRgb::MistyRose] = "mistyrose";
	colorToString[ColorRgb::MistyRose2] = "mistyrose2";
	colorToString[ColorRgb::MistyRose3] = "mistyrose3";
	colorToString[ColorRgb::MistyRose4] = "mistyrose4";
	colorToString[ColorRgb::Moccasin] = "moccasin";
	colorToString[ColorRgb::NavajoWhite] = "navajowhite";
	colorToString[ColorRgb::NavajoWhite2] = "navajowhite2";
	colorToString[ColorRgb::NavajoWhite3] = "navajowhite3";
	colorToString[ColorRgb::NavajoWhite4] = "navajowhite4";
	colorToString[ColorRgb::NiceOrange] = "niceorange";
	colorToString[ColorRgb::NiceBackgroundGray] = "nicebackgroundgray";
	colorToString[ColorRgb::NiceBackgroundGray2] = "nicebackgroundgray2";
	colorToString[ColorRgb::OldLace] = "oldlace";
	colorToString[ColorRgb::OliveDrab] = "olivedrab";
	colorToString[ColorRgb::Orange] = "orange";
	colorToString[ColorRgb::OrangeRed] = "orangered";
	colorToString[ColorRgb::OrangeRed2] = "orangered2";
	colorToString[ColorRgb::OrangeRed3] = "orangered3";
	colorToString[ColorRgb::OrangeRed4] = "orangered4";
	colorToString[ColorRgb::Orchid] = "orchid";
	colorToString[ColorRgb::PaleGoldenRod] = "palegoldenrod";
	colorToString[ColorRgb::PaleGreen] = "palegreen";
	colorToString[ColorRgb::PaleGreen2] = "palegreen2";
	colorToString[ColorRgb::PaleGreen3] = "palegreen3";
	colorToString[ColorRgb::PaleGreen4] = "palegreen4";
	colorToString[ColorRgb::PaleGreen5] = "palegreen5";
	colorToString[ColorRgb::PaleTurquoise] = "paleturquoise";
	colorToString[ColorRgb::PaleTurquoise2] = "paleturquoise2";
	colorToString[ColorRgb::PaleTurquoise3] = "paleturquoise3";
	colorToString[ColorRgb::PaleTurquoise4] = "paleturquoise4";
	colorToString[ColorRgb::PaleTurquoise5] = "paleturquoise5";
	colorToString[ColorRgb::PaleVioletRed] = "palevioletred";
	colorToString[ColorRgb::PaleVioletRed2] = "palevioletred2";
	colorToString[ColorRgb::PaleVioletRed3] = "palevioletred3";
	colorToString[ColorRgb::PaleVioletRed4] = "palevioletred4";
	colorToString[ColorRgb::PaleVioletRed5] = "palevioletred5";
	colorToString[ColorRgb::PapayaWhip] = "papayawhip";
	colorToString[ColorRgb::PeachPuff] = "peachpuff";
	colorToString[ColorRgb::PeachPuff2] = "peachpuff2";
	colorToString[ColorRgb::PeachPuff3] = "peachpuff3";
	colorToString[ColorRgb::PeachPuff4] = "peachpuff4";
	colorToString[ColorRgb::Peru] = "peru";
	colorToString[ColorRgb::Pink] = "pink";
	colorToString[ColorRgb::Plum] = "plum";
	colorToString[ColorRgb::PowderBlue] = "powderblue";
	colorToString[ColorRgb::RosyBrown] = "rosybrown";
	colorToString[ColorRgb::RoyalBlue] = "royalblue";
	colorToString[ColorRgb::SaddleBrown] = "saddlebrown";
	colorToString[ColorRgb::Salmon] = "salmon";
	colorToString[ColorRgb::SandyBrown] = "sandybrown";
	colorToString[ColorRgb::SeaGreen] = "seagreen";
	colorToString[ColorRgb::SeaGreen2] = "seagreen2";
	colorToString[ColorRgb::SeaGreen3] = "seagreen3";
	colorToString[ColorRgb::SeaGreen4] = "seagreen4";
	colorToString[ColorRgb::SeaShell] = "seashell";
	colorToString[ColorRgb::Sienna] = "sienna";
	colorToString[ColorRgb::SkyBlue] = "skyblue";
	colorToString[ColorRgb::SlateBlue] = "slateblue";
	colorToString[ColorRgb::SlateGray] = "slategray";
	colorToString[ColorRgb::SlateGrey] = "slategrey";
	colorToString[ColorRgb::Snow] = "snow";
	colorToString[ColorRgb::SpringGreen] = "springgreen";
	colorToString[ColorRgb::SteelBlue] = "steelblue";
	colorToString[ColorRgb::Tan] = "tan";
	colorToString[ColorRgb::Thistle] = "thistle";
	colorToString[ColorRgb::Tomato] = "tomato";
	colorToString[ColorRgb::Turquoise] = "turquoise";
	colorToString[ColorRgb::Turquoise2] = "turquoise2";
	colorToString[ColorRgb::Turquoise3] = "turquoise3";
	colorToString[ColorRgb::Turquoise4] = "turquoise4";
	colorToString[ColorRgb::Turquoise5] = "turquoise5";
	colorToString[ColorRgb::Violet] = "violet";
	colorToString[ColorRgb::Wheat] = "wheat";
	colorToString[ColorRgb::WhiteSmoke] = "whitesmoke";
	colorToString[ColorRgb::YellowGreen] = "yellowgreen";

	stringToColor.clear();
	for (auto& it : colorToString) {
		stringToColor[it.second] = it.first;
	}
}


RgbaColorf ColorGenerator::getColor(const ColorRgb& color)
{
	// Auto-initialize colors in first usage
	if (colors.size() == 0) {
		ColorGenerator::setupColors();
	}

	return colors[static_cast<std::size_t>(color)];
}


} // End namespace Verso

